import sys
import os
print(f"PWD: {os.getcwd()}", file=sys.stderr)

print(f"Environ: {os.environ}", file=sys.stderr)

sys.path.insert(0, "/root/ipz-server-1/server/cgi/")

from view import View
from httputils import parse_query
'''
def decode_url(url):
    i = 0
    end = len(url)

    decode_buffer = ''
    char_buffer = bytearray()

    while i < end:
        if url[i] == '%':
            try:
                char_buffer.append(int(f'0x{url[i+1:i+3]}', 16))
                decode_buffer += char_buffer.decode("UTF-8")
                del char_buffer[:]
                i += 3
            except:
                i += 3
        else:
            decode_buffer += url[i]
            i += 1

    return decode_buffer

query = [i for i in os.environ['QUERY_STRING'].split("&") if i]

query_dict = {}
for i in query:
    k, v = i.split("=")
    query_dict[decode_url(k)] = decode_url(v)
'''

query_dict = parse_query(os.environ['QUERY_STRING'])

view = View(query_dict)
html_page = view.render_page()
page_length = len(html_page.encode("UTF-8"))

print(f"Content-Type: text/html; charset=UTF-8\r\n" + \
      f"Content-Length: {page_length}\r\n" + \
      f"\r\n" + \
      f"{html_page}")
